# 练习 49：`sed`

> 原文：[Exercise 49: sed](https://learncodethehardway.org/more-python-book/ex49.html)

> 译者：[飞龙](https://github.com/wizardforcel)

> 协议：[CC BY-NC-SA 4.0](http://creativecommons.org/licenses/by-nc-sa/4.0/)

> 自豪地采用[谷歌翻译](https://translate.google.cn/)

当你学习如何制作快速而简陋的黑魔法时，你在练习 9 中实现了一个“低配版”的`sed`。在本练习中，您将尝试实现另一个精确的命令副本。在练习 48 的研究性学习中，您的任务是从您的`ed`实现中创建一个模块。如果你没有这样做，那么你需要为`sed`命令实现它，并且让`sed`使用它。

你的流程怎么样？你是否发现它在这些更长的项目上给了你帮助？有没有你认为需要改变的东西？你是否收集了指标，还是觉得你现在已经渡过了那个阶段？花点时间开始这个练习，看看你的日志，看看自从你开始读这本书以来，你已经改进了多少。

这个练习的挑战是，从练习 48 中的`ed`项目中获取代码，并在该项目中复用它。“可复用性”的概念对于软件的工作方式至关重要，但是很多时候，在项目中复用的计划会导致灾难。人们经常设计软件，以便每个组件可以在其他软件中使用，但是在这样做时，它们只是使设计过于复杂，并没有真正计划在任何其他项目中使用任何东西。最好使软件是离散的、独立的，然后取出可以用的一部分，在启动另一个项目时使用它。

我通常编写我的软件，不会担心可复用性。我不在乎项目的部分是否将用于其他项目。我只关心这一部分软件工作良好，并且质量高。当我启动一个新的项目，我会去看看我写的其他东西，看看有什么我可以再次使用的东西。如果我花时间在较旧的项目中拉出我可以使用的模块。这使我的复用流程看起来像这样：

+   通过自动化测试，实现功能完整的高质量软件。不要在乎用于其他软件的任何其它部分。
+   启动一个新项目，它可能使用另一个项目的代码。
+   回到第一个项目，将代码放入一个单独的模块，使这个第一个项目使用它，并且绝对不更改任何其它东西。
+   在适当的地方使用这个模块，一旦在原始的项目中，我的原始自动化测试运行良好，我就在新项目中使用该模块。
+   最后，尝试在新项目中使用新模块，会发现我需要在模块中进行的更改。我将进行更改，并确保它们与原始软件配合良好。

没有自动化测试的情况下，你不能做到它，所以如果你的`ed`项目没有测试，我想知道是否你读了这本书。回去，并确保你的测试完全覆盖了`ed`项目。

## 挑战练习

首先你要拉取`ed`项目的一部分，它处理命令，并把它放入`ed`所使用的模块中，而不会破坏测试。实话说，这将成为这个项目最难的部分之一，因为`sed`大多只是使用它们，而没有`ed`的交互界面的模态本质。

接下来，您将要从练习 9 中获取旧的代码，并重新启用它，或者在这个新项目上从零开始。一旦你确定了，你将开始使用ed模块实现尽可能多的sed。这项工作的创造力在于，确定两个项目需要使用什么，然后将其放在模块中。

这个实现中，你的目标是，制作一个`sed`命令的精确副本。这部分练习中没有创造力。只要试着尽可能小心，并使用自动化测试来确认，您的命令和原始的`sed`的工作方式是一样的。

最后，当您处理`sed`时，您将在模块中找到所需的东西。您需要对模块进行更改，使其在`sed`中工作，然后返回到`ed`并使其在那里工作。这三个项目之间的弹跳流程将是一个挑战，所以我建议你保持你的 45 分钟的时间块，所以你不会被上下文切换搞晕。

## 研究性学习

当你处理模块时，你是否发现了任何编程习惯，使拉取代码变得困难？它们是什么？
